/*
ATMEGA32           RF12
B7---------------->SCK  
B6---------------->SDO  
B5---------------->SDI  
B4---------------->nSEL 
B3----------------<DATA  (nicht genutzt)
B2----------------<nIRQ 
B1				   LED GREEN
B0				   LED RED
*/

#include <avr/interrupt.h>
#include <avr/io.h>

#include "RFM12.h"
//#include "Display.h"

#define SEND	0x01

int main()
{
	DDRA = 0x00;
	unsigned char test = 0xCC;
	unsigned int i,j;
	//delayms(2);

	//DDR festlegen
	RF12_PORT_INIT();


	//lcd_init();
	//lcd_init();
	//lcd_clr();
	//lcd_clr();
	//delayms(500);
	//RFM12 Register initialisieren
	RF12_INIT();			//Gemeinsame Register

	if(SEND)
	{
		RF12_INIT_TX();		//Register Senden
	}

	if(!SEND)
	{
		RF12_INIT_RX();		//Register Empfangen

	}

	//Power On Test
	
	for(i=0;i<1000;i++)for(j=0;j<123;j++)
	{}
	LEDG_ON();
	LEDR_ON();
	for(i=0;i<1000;i++)for(j=0;j<123;j++)
	{}
	LEDG_OFF();
	LEDR_OFF();

	while(1)
	{	
		//Anzeige2(0x0004,0x08C,0x0016);
		//Sende Funktion
		if(SEND)
		{
			LEDR_ON();
			RF12_WRT_CMD(0x0000);
			RF12_WRT_CMD(0x8238);//!er,!ebb,ET,ES,EX,!eb,!ew,DC		
			RF12_SEND(0xAA);	//PREAMBLE
			RF12_SEND(0xAA);	//PREAMBLE
			RF12_SEND(0xAA);	//PREAMBLE
			RF12_SEND(0x2D);	//SYNC HI BYTE
			RF12_SEND(0xD4);	//SYNC LOW BYTE
			RF12_SEND(test);	//DATA
			RF12_SEND(0xAA);	//DUMMY BYTE
			RF12_SEND(0xAA);	//DUMMY BYTE
			RF12_SEND(0xAA);	//DUMMY BYTE
			RF12_READ_REG();
			
			RF12_WRT_CMD(0x8208);
			LEDR_OFF();
			
			for(i=0;i<5000;)//sleep 1 second appr
			{i++;}
			
		}

		//Empfangs Funktion
		if(!SEND)
		{	
			test=0;
					
			//Start Receiver	
			RF12_WRT_CMD(0x82C9);

			//Enable FIFO
			RF12_WRT_CMD(0xCA83);
			
			//Empfange Byte	
			//RF12_READ_REG();
	
			
			test=RF12_RECEIVE();

			RF12_READ_REG();

			//Stop Receiver
			RF12_WRT_CMD(0x8209);	
			//Anzeige2(test,0x000,0x0000);
			if(test==0xCC)
			{
				LEDG_ON();
				for(i=0;i<1000;i++)for(j=0;j<123;j++);
     	 		LEDG_OFF();
				for(i=0;i<1000;i++)for(j=0;j<123;j++);
    		}
			else
			{
				LEDR_ON();
				for(i=0;i<1000;i++)for(j=0;j<123;j++);
     	 		LEDR_OFF();
				for(i=0;i<1000;i++)for(j=0;j<123;j++);
    		}
			LEDG_OFF();
			LEDR_OFF();			
		}
	}
	return(0);
}


	/*	n=TASTE2;	
		for(n=PINA&0x40;n!=0x40;n=(PINA&0x40))
		{
			
		}*/
