/*
ATMEGA32            RF12
SCK---------------->SCK  B7
MISO--------------->SDO  B6
MOSI--------------->SDI  B5
SS----------------->nSEL B4
	---------------<DATA B3
	---------------<nIRQ B2
LED GREEN				 B1
LED RED					 B0
*/

//Defines
//SCK
#define	RF_SCK			7
#define PORT_SCK		PORTB
#define PIN_SCK			PINB
#define DDR_SCK			DDRB
#define SCK_OUTPUT()	DDR_SCK |= (1<<RF_SCK)
#define HI_SCK()		PORT_SCK|= (1<<RF_SCK)
#define LOW_SCK()		PORT_SCK&=~(1<<RF_SCK)

//SDO
#define RF_SDO			6
#define PORT_SDO		PORTB
#define PIN_SDO			PINB
#define DDR_SDO			DDRB
#define SDO_INPUT()		DDR_SDO&= ~(1<<RF_SDO)
#define SDO_HI()		PIN_SDO&(1<<RF_SDO)


//SDI
#define RF_SDI			5
#define PORT_SDI		PORTB
#define PIN_SDI			PINB
#define DDR_SDI			DDRB
#define SDI_OUTPUT()	DDR_SDI |= (1<<RF_SDI)
#define HI_SDI()		PORT_SDI|= (1<<RF_SDI)
#define LOW_SDI()		PORT_SDI&=~(1<<RF_SDI)

//nSEL
#define	RF_SEL			4
#define PORT_SEL		PORTB
#define PIN_SEL			PINB
#define DDR_SEL			DDRB
#define SEL_OUTPUT()	DDR_SEL |= (1<<RF_SEL)
#define HI_SEL()		PORT_SEL|= (1<<RF_SEL)
#define LOW_SEL()		PORT_SEL&=~(1<<RF_SEL)

//DATA
#define RF12_DATA		3
#define PORT_DATA		PORTB
#define PIN_DATA		PINB
#define DDR_DATA		DDRB
#define DATA_OUT()		DDR_DATA&=~(1<<RF12_DATA)
#define HI_DATA()		PORT_DATA|=(1<<RF12_DATA)
#define LOW_DATA()		PORT_DATA&=~(1<<RF12_DATA)

//nIRQ					
#define RF12_IRQ		2
#define PORT_IRQ		PORTB
#define PIN_IRQ			PINB
#define DDR_IRQ			DDRB
#define IRQ_IN()		DDR_IRQ&=~(1<<RF12_IRQ)
#define HI_IRQ()		PORT_IRQ|=(1<<RF12_IRQ)


//LEDs
#define LEDG			1
#define LEDR			0
#define	LEDG_OUTPUT()	DDRB|=~(1<<LEDG)
#define	LEDR_OUTPUT()	DDRB|=~(1<<LEDR)
#define	LEDG_ON()		PORTB&=~(1<<LEDG)
#define	LEDG_OFF()		PORTB|= (1<<LEDG)
#define	LEDR_ON()		PORTB&=~(1<<LEDR)
#define	LEDR_OFF()		PORTB|= (1<<LEDR)

//Unterprogramme
void RF12_PORT_INIT(void);
unsigned int RF12_WRT_CMD(unsigned int);
void RF12_INIT(void);
void RF12_INIT_TX(void);
void RF12_INIT_RX(void);
void RF12_READ_REG(void);
void RF12_SEND(unsigned char);
unsigned int RF12_RECEIVE(void);
